static const char *RcsId     = "$Header: /home/cvsadm/cvsroot/fermi/servers/adio/src/AdioClass.cpp,v 1.2 2013-10-29 11:27:03 graziano Exp $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        AdioClass.cpp
//
// description : C++ source for the AdioClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the Adio once per process.
//
// project :     TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.2 $
//
// $Log: AdioClass.cpp,v $
// Revision 1.2  2013-10-29 11:27:03  graziano
// Tango 8, Device_4Impl
//
// Revision 1.1  2008/06/24 10:24:38  graziano
// first commit
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <Adio.h>
#include <AdioClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create AdioClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Adio_class(const char *name) {
		return Adio_ns::AdioClass::init(name);
	}
}


namespace Adio_ns
{

//+----------------------------------------------------------------------------
//
// method : 		EnabIrqUpClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *EnabIrqUpClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "EnabIrqUpClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->enab_irq_mask(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		DisabIrqMaskClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DisabIrqMaskClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DisabIrqMaskClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->disab_irq_mask(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SetDebounceClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetDebounceClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetDebounceClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->set_debounce(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetDebounceClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetDebounceClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetDebounceClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_debounce());
}

//+----------------------------------------------------------------------------
//
// method : 		ConfigIOMaskClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ConfigIOMaskClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ConfigIOMaskClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->config_iomask(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		DigInMaskClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DigInMaskClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DigInMaskClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_dig_in_mask());
}

//+----------------------------------------------------------------------------
//
// method : 		DigInClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DigInClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DigInClass::execute(): arrived" << endl;

	const Tango::DevVarShortArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<Adio *>(device))->dig_in(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		SetDigOutMaskClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetDigOutMaskClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetDigOutMaskClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->set_dig_out_mask(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		DigOutMaskClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DigOutMaskClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DigOutMaskClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_dig_out_mask());
}

//+----------------------------------------------------------------------------
//
// method : 		DigOutClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DigOutClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DigOutClass::execute(): arrived" << endl;

	const Tango::DevVarShortArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<Adio *>(device))->dig_out(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		DigOnClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DigOnClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DigOnClass::execute(): arrived" << endl;

	const Tango::DevVarShortArray	*argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->dig_on(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		DigOffClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DigOffClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DigOffClass::execute(): arrived" << endl;

	const Tango::DevVarShortArray	*argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->dig_off(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		DigPulseClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DigPulseClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DigPulseClass::execute(): arrived" << endl;

	const Tango::DevVarShortArray	*argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->dig_pulse(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetDacCtrlClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetDacCtrlClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetDacCtrlClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_dac_ctrl());
}

//+----------------------------------------------------------------------------
//
// method : 		SetDcDacClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetDcDacClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetDcDacClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->set_dc_dac(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetDcDacClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetDcDacClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetDcDacClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_dc_dac());
}

//+----------------------------------------------------------------------------
//
// method : 		SetAcDacClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetAcDacClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetAcDacClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->set_ac_dac(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetAcDacClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetAcDacClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetAcDacClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_ac_dac());
}

//+----------------------------------------------------------------------------
//
// method : 		GetAdcClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetAdcClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetAdcClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_adc());
}

//+----------------------------------------------------------------------------
//
// method : 		GetAdcVoltClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetAdcVoltClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetAdcVoltClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_adc_volt());
}

//+----------------------------------------------------------------------------
//
// method : 		SetAdcLowThClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetAdcLowThClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetAdcLowThClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->set_dac_low_th(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetAdcLowThClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetAdcLowThClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetAdcLowThClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_dac_low_th());
}

//+----------------------------------------------------------------------------
//
// method : 		SetAdcHighThClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetAdcHighThClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetAdcHighThClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->set_dac_high_th(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetAdcHighThClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetAdcHighThClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetAdcHighThClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_dac_high_th());
}

//+----------------------------------------------------------------------------
//
// method : 		GetSetPntClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetSetPntClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetSetPntClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_set_pnt());
}

//+----------------------------------------------------------------------------
//
// method : 		GetPinConnectorCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetPinConnectorCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetPinConnectorCmd::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	return insert((static_cast<Adio *>(device))->get_pin_connector(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetAcDacVoltClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetAcDacVoltClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetAcDacVoltClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_ac_dac_volt());
}

//+----------------------------------------------------------------------------
//
// method : 		GetDigIOMaskClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetDigIOMaskClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetDigIOMaskClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_config_iomask());
}

//+----------------------------------------------------------------------------
//
// method : 		SetAcDacVoltClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetAcDacVoltClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetAcDacVoltClass::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->set_ac_dac_volt(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SetDcDacVoltClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetDcDacVoltClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetDcDacVoltClass::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->set_dc_dac_volt(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		RegisterChannelsCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *RegisterChannelsCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "RegisterChannelsCmd::execute(): arrived" << endl;

	const Tango::DevVarUShortArray	*argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->register_channels(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UnregisterChannelsClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UnregisterChannelsClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UnregisterChannelsClass::execute(): arrived" << endl;

	const Tango::DevVarUShortArray	*argin;
	extract(in_any, argin);

	((static_cast<Adio *>(device))->unregister_channels(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetChannelsConfigClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetChannelsConfigClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetChannelsConfigClass::execute(): arrived" << endl;

	return insert((static_cast<Adio *>(device))->get_channels_config());
}


//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
AdioClass *AdioClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		AdioClass::AdioClass(string &s)
// 
// description : 	constructor for the AdioClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
AdioClass::AdioClass(string &s):DeviceClass(s)
{

	cout2 << "Entering AdioClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving AdioClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		AdioClass::~AdioClass()
// 
// description : 	destructor for the AdioClass
//
//-----------------------------------------------------------------------------
AdioClass::~AdioClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		AdioClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
AdioClass *AdioClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new AdioClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

AdioClass *AdioClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		AdioClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void AdioClass::command_factory()
{
	command_list.push_back(new EnabIrqUpClass("EnabIrqMask",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DisabIrqMaskClass("DisabIrqMask",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetDebounceClass("SetDebounce",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"debounce factor",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetDebounceClass("GetDebounce",
		Tango::DEV_VOID, Tango::DEV_SHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ConfigIOMaskClass("ConfigIOMask",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"iomask",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DigInMaskClass("GetDigInMask",
		Tango::DEV_VOID, Tango::DEV_USHORT,
		"",
		"mask",
		Tango::OPERATOR));
	command_list.push_back(new DigInClass("DigIn",
		Tango::DEVVAR_SHORTARRAY, Tango::DEVVAR_SHORTARRAY,
		"array of channels",
		"array of levels",
		Tango::OPERATOR));
	command_list.push_back(new SetDigOutMaskClass("SetDigOutMask",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DigOutMaskClass("GetDigOutMask",
		Tango::DEV_VOID, Tango::DEV_USHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DigOutClass("DigOut",
		Tango::DEVVAR_SHORTARRAY, Tango::DEVVAR_SHORTARRAY,
		"channel",
		"level",
		Tango::OPERATOR));
	command_list.push_back(new DigOnClass("DigOn",
		Tango::DEVVAR_SHORTARRAY, Tango::DEV_VOID,
		"array of channel",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DigOffClass("DigOff",
		Tango::DEVVAR_SHORTARRAY, Tango::DEV_VOID,
		"array of channels",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DigPulseClass("DigPulse",
		Tango::DEVVAR_SHORTARRAY, Tango::DEV_VOID,
		"array of channels",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetDacCtrlClass("GetDacCtrl",
		Tango::DEV_VOID, Tango::DEV_SHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetDcDacClass("SetDcDac",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"dc value",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetDcDacClass("GetDcDac",
		Tango::DEV_VOID, Tango::DEV_SHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetAcDacClass("SetAcDac",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetAcDacClass("GetAcDac",
		Tango::DEV_VOID, Tango::DEV_SHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetAdcClass("GetAdc",
		Tango::DEV_VOID, Tango::DEV_SHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetAdcVoltClass("GetAdcVolt",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetAdcLowThClass("SetDacLowTh",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetAdcLowThClass("GetDacLowTh",
		Tango::DEV_VOID, Tango::DEV_SHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetAdcHighThClass("SetDacHighTh",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetAdcHighThClass("GetDacHighTh",
		Tango::DEV_VOID, Tango::DEV_SHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetSetPntClass("GetSetPnt",
		Tango::DEV_VOID, Tango::DEV_SHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetPinConnectorCmd("GetPinConnector",
		Tango::DEV_SHORT, Tango::DEV_STRING,
		"channel",
		"pinout",
		Tango::OPERATOR));
	command_list.push_back(new GetAcDacVoltClass("GetAcDacVolt",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetDigIOMaskClass("GetConfigIOMask",
		Tango::DEV_VOID, Tango::DEV_USHORT,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetAcDacVoltClass("SetAcDacVolt",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetDcDacVoltClass("SetDcDacVolt",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new RegisterChannelsCmd("RegisterChannels",
		Tango::DEVVAR_USHORTARRAY, Tango::DEV_VOID,
		"list of channel to set as used",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UnregisterChannelsClass("UnregisterChannels",
		Tango::DEVVAR_USHORTARRAY, Tango::DEV_VOID,
		"list of channel to set as not used",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetChannelsConfigClass("GetChannelsConfig",
		Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
		"",
		"config (in/out, used/not_used) of every digital channel",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		AdioClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum AdioClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		AdioClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum AdioClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		AdioClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum AdioClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		AdioClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void AdioClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new Adio(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 		AdioClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void AdioClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	AdioClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void AdioClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "Adioname";
	prop_desc = "Adio devicename Ex. /dev/adio0";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Ioconnector";
	prop_desc = "This is the the P2 Vme backplane pinout of the ADIO board.\nChannel 0-7:digital In/Out\nChannel 8-11:digital In\nChannel 12: DAC\nChannel 13: ADC";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Iomask";
	prop_desc = "Config input output channels bitmask: 0=output 1=input";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		AdioClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void AdioClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Adio");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This is the device server of the ADIO INCAA Digital Adc/Dac board");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
